import { DegreePlannerDataService } from './../../../core/service/degree-planner-data.service';
import { Component, OnInit, Input, Inject } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA } from '@angular/material';
import { DataService } from '../../../core/data.service';
import { Course } from '../../../core/models/course';
import { SavedForLaterCourse } from '../../../core/models/saved-for-later-course';

import { DegreePlannerState } from '@app/degree-planner/state';
import { Store } from '@ngrx/store';

import {
	RemoveCourseRequest
} from '@app/degree-planner/actions/plan.actions';

@Component({
	selector: 'cse-remove-course-confirm-dialog',
	templateUrl: './remove-course-confirm-dialog.component.html',
	styleUrls: ['./remove-course-confirm-dialog.component.scss']
})
export class RemoveCourseConfirmDialogComponent implements OnInit {
	course: Course;
	savedForLater: Boolean;
	courses: Course[];
	type: 'saved' | 'course' | 'search';
	favoriteCourses: SavedForLaterCourse[];

	// tslint:disable-next-line:max-line-length
	constructor(private dataService: DataService,
		private dialogRef: MatDialogRef<RemoveCourseConfirmDialogComponent>,
		private degreePlannerDataSvc: DegreePlannerDataService,
		private store: Store<{ degreePlanner: DegreePlannerState }>,
		@Inject(MAT_DIALOG_DATA) data: any) {
		this.course = data.course;
		this.type = data.type;
	}

	ngOnInit() {}

	removeCourse() {
		switch (this.type) {
			case 'saved':
				console.log('remove course from saved');
				break;

			case 'course':
				console.log('remove course from term');
				console.log(this.course);
				this.store.dispatch(new RemoveCourseRequest({ id: this.course.id }));
				break;
		}
	}
}
